/* SidebarListInterface.c generated by valac 0.56.18, the Vala compiler
 * generated from SidebarListInterface.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-2.0+
 * SPDX-FileCopyrightText: 2020-2023 elementary, Inc. (https://elementary.io)
 *
 * Authors : Jeremy Wootten <jeremywootten@gmail.com>
 */

#include "pantheon-files-core.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static void sidebar_sidebar_list_interface_real_refresh_info (SidebarSidebarListInterface* self);
static void sidebar_sidebar_list_interface_real_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                                 const gchar* uri,
                                                                 const gchar* new_name);
static void sidebar_sidebar_list_interface_real_open_item (SidebarSidebarListInterface* self,
                                                    SidebarSidebarItemInterface* item,
                                                    FilesOpenFlag flag);
static guint32 sidebar_sidebar_list_interface_real_add_plugin_item (SidebarSidebarListInterface* self,
                                                             FilesSidebarPluginItem* plugin_item);
static void sidebar_sidebar_list_interface_real_clear (SidebarSidebarListInterface* self);
static gboolean sidebar_sidebar_list_interface_real_has_uri (SidebarSidebarListInterface* self,
                                                      const gchar* uri,
                                                      GtkListBoxRow** row);
static gboolean sidebar_sidebar_list_interface_real_select_uri (SidebarSidebarListInterface* self,
                                                         const gchar* uri);
static gboolean sidebar_sidebar_list_interface_real_remove_item_by_id (SidebarSidebarListInterface* self,
                                                                guint32 id);
static gboolean sidebar_sidebar_list_interface_real_add_favorite (SidebarSidebarListInterface* self,
                                                           const gchar* uri,
                                                           const gchar* label,
                                                           gint index);
static SidebarSidebarItemInterface* sidebar_sidebar_list_interface_real_get_item_at_index (SidebarSidebarListInterface* self,
                                                                                    gint index);
static gboolean sidebar_sidebar_list_interface_real_move_item_after (SidebarSidebarListInterface* self,
                                                              SidebarSidebarItemInterface* item,
                                                              gint target_index);
static gboolean sidebar_sidebar_list_interface_real_is_drop_target (SidebarSidebarListInterface* self);
static GType sidebar_sidebar_list_interface_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
sidebar_sidebar_list_interface_select_item (SidebarSidebarListInterface* self,
                                            GtkListBoxRow* item)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 12 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 12 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 12 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->select_item) {
#line 12 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->select_item (self, item);
#line 73 "SidebarListInterface.c"
	}
}

void
sidebar_sidebar_list_interface_unselect_all_items (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 13 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 13 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 13 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->unselect_all_items) {
#line 13 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->unselect_all_items (self);
#line 89 "SidebarListInterface.c"
	}
}

void
sidebar_sidebar_list_interface_refresh (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 14 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 14 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 14 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->refresh) {
#line 14 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->refresh (self);
#line 105 "SidebarListInterface.c"
	}
}

static void
sidebar_sidebar_list_interface_real_refresh_info (SidebarSidebarListInterface* self)
{
}

void
sidebar_sidebar_list_interface_refresh_info (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 16 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 16 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 16 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->refresh_info) {
#line 16 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->refresh_info (self);
#line 126 "SidebarListInterface.c"
	}
}

static void
sidebar_sidebar_list_interface_real_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                            const gchar* uri,
                                                            const gchar* new_name)
{
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (uri != NULL);
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (new_name != NULL);
#line 139 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_rename_bookmark_by_uri (SidebarSidebarListInterface* self,
                                                       const gchar* uri,
                                                       const gchar* new_name)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->rename_bookmark_by_uri) {
#line 17 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->rename_bookmark_by_uri (self, uri, new_name);
#line 156 "SidebarListInterface.c"
	}
}

static void
sidebar_sidebar_list_interface_real_open_item (SidebarSidebarListInterface* self,
                                               SidebarSidebarItemInterface* item,
                                               FilesOpenFlag flag)
{
	FilesSidebarInterface* _tmp0_;
	FilesSidebarInterface* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 18 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (item != NULL);
#line 19 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_sidebar (self);
#line 19 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = _tmp0_;
#line 19 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = sidebar_sidebar_item_interface_get_uri (item);
#line 19 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp3_ = _tmp2_;
#line 19 "../libcore/Interfaces/SidebarListInterface.vala"
	g_signal_emit_by_name (_tmp1_, "path-change-request", _tmp3_, flag);
#line 181 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_open_item (SidebarSidebarListInterface* self,
                                          SidebarSidebarItemInterface* item,
                                          FilesOpenFlag flag)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 18 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 18 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 18 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->open_item) {
#line 18 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->open_item (self, item, flag);
#line 198 "SidebarListInterface.c"
	}
}

static guint32
sidebar_sidebar_list_interface_real_add_plugin_item (SidebarSidebarListInterface* self,
                                                     FilesSidebarPluginItem* plugin_item)
{
	guint32 result;
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (plugin_item != NULL, 0U);
#line 23 "../libcore/Interfaces/SidebarListInterface.vala"
	result = (guint32) 0;
#line 23 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 213 "SidebarListInterface.c"
}

guint32
sidebar_sidebar_list_interface_add_plugin_item (SidebarSidebarListInterface* self,
                                                FilesSidebarPluginItem* plugin_item)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->add_plugin_item) {
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->add_plugin_item (self, plugin_item);
#line 229 "SidebarListInterface.c"
	}
#line 22 "../libcore/Interfaces/SidebarListInterface.vala"
	return 0U;
#line 233 "SidebarListInterface.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	return self ? g_object_ref (self) : NULL;
#line 241 "SidebarListInterface.c"
}

static void
sidebar_sidebar_list_interface_real_clear (SidebarSidebarListInterface* self)
{
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = _tmp0_;
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = gtk_list_box_get_row_at_index (_tmp1_, 0);
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 27 "../libcore/Interfaces/SidebarListInterface.vala"
	row = _tmp3_;
#line 28 "../libcore/Interfaces/SidebarListInterface.vala"
	while (TRUE) {
#line 264 "SidebarListInterface.c"
		GtkListBoxRow* _tmp4_;
		GtkListBox* _tmp5_;
		GtkListBox* _tmp6_;
		GtkListBoxRow* _tmp7_;
		GtkListBoxRow* _tmp8_;
		GtkListBox* _tmp10_;
		GtkListBox* _tmp11_;
		GtkListBoxRow* _tmp12_;
		GtkListBoxRow* _tmp13_;
#line 28 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp4_ = row;
#line 28 "../libcore/Interfaces/SidebarListInterface.vala"
		if (!(_tmp4_ != NULL)) {
#line 28 "../libcore/Interfaces/SidebarListInterface.vala"
			break;
#line 280 "SidebarListInterface.c"
		}
#line 29 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp5_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 29 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp6_ = _tmp5_;
#line 29 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp7_ = row;
#line 29 "../libcore/Interfaces/SidebarListInterface.vala"
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 30 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp8_ = row;
#line 30 "../libcore/Interfaces/SidebarListInterface.vala"
		if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp8_)) {
#line 294 "SidebarListInterface.c"
			GtkListBoxRow* _tmp9_;
#line 31 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp9_ = row;
#line 31 "../libcore/Interfaces/SidebarListInterface.vala"
			sidebar_sidebar_item_interface_destroy_bookmark (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface));
#line 300 "SidebarListInterface.c"
		}
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp10_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp11_ = _tmp10_;
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp12_ = gtk_list_box_get_row_at_index (_tmp11_, 0);
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		_g_object_unref0 (row);
#line 34 "../libcore/Interfaces/SidebarListInterface.vala"
		row = _tmp13_;
#line 314 "SidebarListInterface.c"
	}
#line 26 "../libcore/Interfaces/SidebarListInterface.vala"
	_g_object_unref0 (row);
#line 318 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_clear (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 26 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 26 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 26 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->clear) {
#line 26 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->clear (self);
#line 333 "SidebarListInterface.c"
	}
}

static gboolean
sidebar_sidebar_list_interface_real_has_uri (SidebarSidebarListInterface* self,
                                             const gchar* uri,
                                             GtkListBoxRow** row)
{
	GtkListBoxRow* _vala_row = NULL;
	gint index = 0;
	GtkListBoxRow* child = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
	gboolean result;
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 39 "../libcore/Interfaces/SidebarListInterface.vala"
	_vala_row = NULL;
#line 40 "../libcore/Interfaces/SidebarListInterface.vala"
	index = 0;
#line 41 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 41 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = _tmp0_;
#line 41 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = gtk_list_box_get_row_at_index (_tmp1_, index);
#line 41 "../libcore/Interfaces/SidebarListInterface.vala"
	child = _tmp2_;
#line 42 "../libcore/Interfaces/SidebarListInterface.vala"
	while (TRUE) {
#line 365 "SidebarListInterface.c"
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
		GtkListBox* _tmp9_;
		GtkListBox* _tmp10_;
		gint _tmp11_;
		GtkListBoxRow* _tmp12_;
#line 42 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp3_ = child;
#line 42 "../libcore/Interfaces/SidebarListInterface.vala"
		if (!(_tmp3_ != NULL)) {
#line 42 "../libcore/Interfaces/SidebarListInterface.vala"
			break;
#line 378 "SidebarListInterface.c"
		}
#line 43 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp4_ = child;
#line 43 "../libcore/Interfaces/SidebarListInterface.vala"
		if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp4_)) {
#line 384 "SidebarListInterface.c"
			GtkListBoxRow* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 44 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp5_ = child;
#line 44 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp6_ = sidebar_sidebar_item_interface_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface));
#line 44 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp7_ = _tmp6_;
#line 44 "../libcore/Interfaces/SidebarListInterface.vala"
			if (g_strcmp0 (_tmp7_, uri) == 0) {
#line 396 "SidebarListInterface.c"
				GtkListBoxRow* _tmp8_;
#line 45 "../libcore/Interfaces/SidebarListInterface.vala"
				_tmp8_ = child;
#line 45 "../libcore/Interfaces/SidebarListInterface.vala"
				_vala_row = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_list_box_row_get_type (), GtkListBoxRow);
#line 46 "../libcore/Interfaces/SidebarListInterface.vala"
				result = TRUE;
#line 46 "../libcore/Interfaces/SidebarListInterface.vala"
				if (row) {
#line 46 "../libcore/Interfaces/SidebarListInterface.vala"
					*row = _vala_row;
#line 408 "SidebarListInterface.c"
				}
#line 46 "../libcore/Interfaces/SidebarListInterface.vala"
				return result;
#line 412 "SidebarListInterface.c"
			}
		}
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp9_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp10_ = _tmp9_;
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		index = index + 1;
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp11_ = index;
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp12_ = gtk_list_box_get_row_at_index (_tmp10_, _tmp11_);
#line 50 "../libcore/Interfaces/SidebarListInterface.vala"
		child = _tmp12_;
#line 427 "SidebarListInterface.c"
	}
#line 53 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 53 "../libcore/Interfaces/SidebarListInterface.vala"
	if (row) {
#line 53 "../libcore/Interfaces/SidebarListInterface.vala"
		*row = _vala_row;
#line 435 "SidebarListInterface.c"
	}
#line 53 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 439 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_has_uri (SidebarSidebarListInterface* self,
                                        const gchar* uri,
                                        GtkListBoxRow** row)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->has_uri) {
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->has_uri (self, uri, row);
#line 456 "SidebarListInterface.c"
	}
#line 38 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 460 "SidebarListInterface.c"
}

static gboolean
sidebar_sidebar_list_interface_real_select_uri (SidebarSidebarListInterface* self,
                                                const gchar* uri)
{
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp0_ = NULL;
	gboolean _tmp1_;
	GtkListBoxRow* _tmp2_;
	gboolean result;
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 57 "../libcore/Interfaces/SidebarListInterface.vala"
	sidebar_sidebar_list_interface_unselect_all_items (self);
#line 58 "../libcore/Interfaces/SidebarListInterface.vala"
	row = NULL;
#line 59 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = sidebar_sidebar_list_interface_has_uri (self, uri, &_tmp0_);
#line 59 "../libcore/Interfaces/SidebarListInterface.vala"
	_g_object_unref0 (row);
#line 59 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = _g_object_ref0 (_tmp0_);
#line 59 "../libcore/Interfaces/SidebarListInterface.vala"
	row = _tmp2_;
#line 59 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_tmp1_) {
#line 488 "SidebarListInterface.c"
		GtkListBoxRow* _tmp3_;
#line 60 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp3_ = row;
#line 60 "../libcore/Interfaces/SidebarListInterface.vala"
		sidebar_sidebar_list_interface_select_item (self, _tmp3_);
#line 61 "../libcore/Interfaces/SidebarListInterface.vala"
		result = TRUE;
#line 61 "../libcore/Interfaces/SidebarListInterface.vala"
		_g_object_unref0 (row);
#line 61 "../libcore/Interfaces/SidebarListInterface.vala"
		return result;
#line 500 "SidebarListInterface.c"
	}
#line 64 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 64 "../libcore/Interfaces/SidebarListInterface.vala"
	_g_object_unref0 (row);
#line 64 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 508 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_select_uri (SidebarSidebarListInterface* self,
                                           const gchar* uri)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->select_uri) {
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->select_uri (self, uri);
#line 524 "SidebarListInterface.c"
	}
#line 56 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 528 "SidebarListInterface.c"
}

static gboolean
sidebar_sidebar_list_interface_real_remove_item_by_id (SidebarSidebarListInterface* self,
                                                       guint32 id)
{
	gint index = 0;
	GtkListBoxRow* child = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
	gboolean result;
#line 68 "../libcore/Interfaces/SidebarListInterface.vala"
	index = 0;
#line 69 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 69 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = _tmp0_;
#line 69 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = gtk_list_box_get_row_at_index (_tmp1_, index);
#line 69 "../libcore/Interfaces/SidebarListInterface.vala"
	child = _tmp2_;
#line 70 "../libcore/Interfaces/SidebarListInterface.vala"
	while (TRUE) {
#line 553 "SidebarListInterface.c"
		GtkListBoxRow* _tmp3_;
		GtkListBoxRow* _tmp4_;
		GtkListBox* _tmp16_;
		GtkListBox* _tmp17_;
		gint _tmp18_;
		GtkListBoxRow* _tmp19_;
#line 70 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp3_ = child;
#line 70 "../libcore/Interfaces/SidebarListInterface.vala"
		if (!(_tmp3_ != NULL)) {
#line 70 "../libcore/Interfaces/SidebarListInterface.vala"
			break;
#line 566 "SidebarListInterface.c"
		}
#line 71 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp4_ = child;
#line 71 "../libcore/Interfaces/SidebarListInterface.vala"
		if (SIDEBAR_IS_SIDEBAR_ITEM_INTERFACE (_tmp4_)) {
#line 572 "SidebarListInterface.c"
			SidebarSidebarItemInterface* row = NULL;
			GtkListBoxRow* _tmp5_;
			SidebarSidebarItemInterface* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
			SidebarSidebarItemInterface* _tmp9_;
			guint32 _tmp10_;
			guint32 _tmp11_;
#line 72 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp5_ = child;
#line 72 "../libcore/Interfaces/SidebarListInterface.vala"
			row = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface);
#line 73 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp6_ = row;
#line 73 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp7_ = sidebar_sidebar_item_interface_get_permanent (_tmp6_);
#line 73 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp8_ = _tmp7_;
#line 73 "../libcore/Interfaces/SidebarListInterface.vala"
			if (_tmp8_) {
#line 74 "../libcore/Interfaces/SidebarListInterface.vala"
				continue;
#line 595 "SidebarListInterface.c"
			}
#line 77 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp9_ = row;
#line 77 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp10_ = sidebar_sidebar_item_interface_get_id (_tmp9_);
#line 77 "../libcore/Interfaces/SidebarListInterface.vala"
			_tmp11_ = _tmp10_;
#line 77 "../libcore/Interfaces/SidebarListInterface.vala"
			if (_tmp11_ == id) {
#line 605 "SidebarListInterface.c"
				GtkListBox* _tmp12_;
				GtkListBox* _tmp13_;
				GtkListBoxRow* _tmp14_;
				SidebarSidebarItemInterface* _tmp15_;
#line 78 "../libcore/Interfaces/SidebarListInterface.vala"
				_tmp12_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 78 "../libcore/Interfaces/SidebarListInterface.vala"
				_tmp13_ = _tmp12_;
#line 78 "../libcore/Interfaces/SidebarListInterface.vala"
				_tmp14_ = child;
#line 78 "../libcore/Interfaces/SidebarListInterface.vala"
				gtk_container_remove ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 79 "../libcore/Interfaces/SidebarListInterface.vala"
				_tmp15_ = row;
#line 79 "../libcore/Interfaces/SidebarListInterface.vala"
				sidebar_sidebar_item_interface_destroy_bookmark (_tmp15_);
#line 80 "../libcore/Interfaces/SidebarListInterface.vala"
				result = TRUE;
#line 80 "../libcore/Interfaces/SidebarListInterface.vala"
				return result;
#line 626 "SidebarListInterface.c"
			}
		}
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp16_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp17_ = _tmp16_;
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		index = index + 1;
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp18_ = index;
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp19_ = gtk_list_box_get_row_at_index (_tmp17_, _tmp18_);
#line 84 "../libcore/Interfaces/SidebarListInterface.vala"
		child = _tmp19_;
#line 641 "SidebarListInterface.c"
	}
#line 87 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 87 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 647 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_remove_item_by_id (SidebarSidebarListInterface* self,
                                                  guint32 id)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 67 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 67 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->remove_item_by_id) {
#line 67 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->remove_item_by_id (self, id);
#line 663 "SidebarListInterface.c"
	}
#line 67 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 667 "SidebarListInterface.c"
}

static gboolean
sidebar_sidebar_list_interface_real_add_favorite (SidebarSidebarListInterface* self,
                                                  const gchar* uri,
                                                  const gchar* label,
                                                  gint index)
{
	gboolean result;
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (label != NULL, FALSE);
#line 92 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 92 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 685 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_add_favorite (SidebarSidebarListInterface* self,
                                             const gchar* uri,
                                             const gchar* label,
                                             gint index)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->add_favorite) {
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->add_favorite (self, uri, label, index);
#line 703 "SidebarListInterface.c"
	}
#line 91 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 707 "SidebarListInterface.c"
}

static SidebarSidebarItemInterface*
sidebar_sidebar_list_interface_real_get_item_at_index (SidebarSidebarListInterface* self,
                                                       gint index)
{
	SidebarSidebarItemInterface* result;
#line 96 "../libcore/Interfaces/SidebarListInterface.vala"
	result = NULL;
#line 96 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 719 "SidebarListInterface.c"
}

SidebarSidebarItemInterface*
sidebar_sidebar_list_interface_get_item_at_index (SidebarSidebarListInterface* self,
                                                  gint index)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 95 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 95 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->get_item_at_index) {
#line 95 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->get_item_at_index (self, index);
#line 735 "SidebarListInterface.c"
	}
#line 95 "../libcore/Interfaces/SidebarListInterface.vala"
	return NULL;
#line 739 "SidebarListInterface.c"
}

static gboolean
sidebar_sidebar_list_interface_real_move_item_after (SidebarSidebarListInterface* self,
                                                     SidebarSidebarItemInterface* item,
                                                     gint target_index)
{
	gboolean result;
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 101 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 101 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 754 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_move_item_after (SidebarSidebarListInterface* self,
                                                SidebarSidebarItemInterface* item,
                                                gint target_index)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->move_item_after) {
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->move_item_after (self, item, target_index);
#line 771 "SidebarListInterface.c"
	}
#line 100 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 775 "SidebarListInterface.c"
}

static gboolean
sidebar_sidebar_list_interface_real_is_drop_target (SidebarSidebarListInterface* self)
{
	gboolean result;
#line 106 "../libcore/Interfaces/SidebarListInterface.vala"
	result = FALSE;
#line 106 "../libcore/Interfaces/SidebarListInterface.vala"
	return result;
#line 786 "SidebarListInterface.c"
}

gboolean
sidebar_sidebar_list_interface_is_drop_target (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 105 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 105 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->is_drop_target) {
#line 105 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->is_drop_target (self);
#line 801 "SidebarListInterface.c"
	}
#line 105 "../libcore/Interfaces/SidebarListInterface.vala"
	return FALSE;
#line 805 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_focus (SidebarSidebarListInterface* self)
{
	GtkListBoxRow* focus_row = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
	GtkListBoxRow* _tmp3_;
	GtkListBoxRow* _tmp4_;
	GtkListBoxRow* _tmp9_;
#line 110 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 110 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp1_ = _tmp0_;
#line 110 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp2_ = gtk_list_box_get_selected_row (_tmp1_);
#line 110 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 110 "../libcore/Interfaces/SidebarListInterface.vala"
	focus_row = _tmp3_;
#line 111 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp4_ = focus_row;
#line 111 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_tmp4_ == NULL) {
#line 832 "SidebarListInterface.c"
		GtkListBox* _tmp5_;
		GtkListBox* _tmp6_;
		GtkListBoxRow* _tmp7_;
		GtkListBoxRow* _tmp8_;
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp5_ = sidebar_sidebar_list_interface_get_list_box (self);
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp6_ = _tmp5_;
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp7_ = gtk_list_box_get_row_at_index (_tmp6_, 0);
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		_g_object_unref0 (focus_row);
#line 112 "../libcore/Interfaces/SidebarListInterface.vala"
		focus_row = _tmp8_;
#line 849 "SidebarListInterface.c"
	}
#line 115 "../libcore/Interfaces/SidebarListInterface.vala"
	_tmp9_ = focus_row;
#line 115 "../libcore/Interfaces/SidebarListInterface.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 109 "../libcore/Interfaces/SidebarListInterface.vala"
	_g_object_unref0 (focus_row);
#line 857 "SidebarListInterface.c"
}

FilesSidebarInterface*
sidebar_sidebar_list_interface_get_sidebar (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->get_sidebar) {
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->get_sidebar (self);
#line 872 "SidebarListInterface.c"
	}
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	return NULL;
#line 876 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_set_sidebar (SidebarSidebarListInterface* self,
                                            FilesSidebarInterface* value)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->set_sidebar) {
#line 9 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->set_sidebar (self, value);
#line 892 "SidebarListInterface.c"
	}
}

GtkListBox*
sidebar_sidebar_list_interface_get_list_box (SidebarSidebarListInterface* self)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->get_list_box) {
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
		return _iface_->get_list_box (self);
#line 908 "SidebarListInterface.c"
	}
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	return NULL;
#line 912 "SidebarListInterface.c"
}

void
sidebar_sidebar_list_interface_set_list_box (SidebarSidebarListInterface* self,
                                             GtkListBox* value)
{
	SidebarSidebarListInterfaceIface* _iface_;
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	g_return_if_fail (self != NULL);
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_LIST_INTERFACE_GET_INTERFACE (self);
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
	if (_iface_->set_list_box) {
#line 10 "../libcore/Interfaces/SidebarListInterface.vala"
		_iface_->set_list_box (self, value);
#line 928 "SidebarListInterface.c"
	}
}

static void
sidebar_sidebar_list_interface_default_init (SidebarSidebarListInterfaceIface * iface,
                                             gpointer iface_data)
{
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("sidebar", "sidebar", "sidebar", FILES_TYPE_SIDEBAR_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("list-box", "list-box", "list-box", gtk_list_box_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->refresh_info = sidebar_sidebar_list_interface_real_refresh_info;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->rename_bookmark_by_uri = sidebar_sidebar_list_interface_real_rename_bookmark_by_uri;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->open_item = sidebar_sidebar_list_interface_real_open_item;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->add_plugin_item = sidebar_sidebar_list_interface_real_add_plugin_item;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->clear = sidebar_sidebar_list_interface_real_clear;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->has_uri = sidebar_sidebar_list_interface_real_has_uri;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->select_uri = sidebar_sidebar_list_interface_real_select_uri;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->remove_item_by_id = sidebar_sidebar_list_interface_real_remove_item_by_id;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->add_favorite = sidebar_sidebar_list_interface_real_add_favorite;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->get_item_at_index = sidebar_sidebar_list_interface_real_get_item_at_index;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->move_item_after = sidebar_sidebar_list_interface_real_move_item_after;
#line 8 "../libcore/Interfaces/SidebarListInterface.vala"
	iface->is_drop_target = sidebar_sidebar_list_interface_real_is_drop_target;
#line 964 "SidebarListInterface.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_sidebar_list_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarSidebarListInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_sidebar_list_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType sidebar_sidebar_list_interface_type_id;
	sidebar_sidebar_list_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SidebarSidebarListInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (sidebar_sidebar_list_interface_type_id, G_TYPE_OBJECT);
	return sidebar_sidebar_list_interface_type_id;
}

GType
sidebar_sidebar_list_interface_get_type (void)
{
	static volatile gsize sidebar_sidebar_list_interface_type_id__once = 0;
	if (g_once_init_enter (&sidebar_sidebar_list_interface_type_id__once)) {
		GType sidebar_sidebar_list_interface_type_id;
		sidebar_sidebar_list_interface_type_id = sidebar_sidebar_list_interface_get_type_once ();
		g_once_init_leave (&sidebar_sidebar_list_interface_type_id__once, sidebar_sidebar_list_interface_type_id);
	}
	return sidebar_sidebar_list_interface_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

